"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
require('dotenv').config();
const debug_1 = __importDefault(require("debug"));
const chance_1 = __importDefault(require("chance"));
const multidirectional_1 = require("../imports/multidirectional");
const chance = new chance_1.default();
const debug = (0, debug_1.default)('materialized-path:test');
const SCHEMA = process.env.MIGRATIONS_SCHEMA || 'public';
const MP_TABLE = process.env.MIGRATIONS_MP_TABLE || 'mp_example__links__mp_md';
const GRAPH_TABLE = process.env.MIGRATIONS_GRAPH_TABLE || 'mp_example__links_md';
const ID_TYPE = process.env.MIGRATIONS_ID_TYPE_GQL || 'Int';
const DELAY = +process.env.DELAY || 0;
const delay = time => new Promise(res => setTimeout(res, time));
const itDelay = () => {
    if (DELAY) {
        (it)('delay', () => __awaiter(void 0, void 0, void 0, function* () {
            yield delay(DELAY);
        }));
    }
};
beforeAll(multidirectional_1.beforeAllHandler);
(it)('prepare', multidirectional_1.prepare);
it('+15', (0, multidirectional_1.testPlus15)(true));
itDelay();
it('-15', (0, multidirectional_1.testMinus15)(true));
itDelay();
it('recursive', (0, multidirectional_1.testRecursive)(true));
itDelay();
it('recursiveSameRoot', (0, multidirectional_1.testRecursiveSameRoot)(true));
itDelay();
it('testSeparation1', (0, multidirectional_1.testSeparation1)(true));
itDelay();
it('testSeparation2', (0, multidirectional_1.testSeparation2)(true));
//# sourceMappingURL=multidirectional.js.map